// Author:       Andreas F. Borchert
// Description:  maintains a list of friends in sorted
//               order using binary trees

#ifndef LIST_OF_FRIENDS_H
#define LIST_OF_FRIENDS_H

#include "Friend.h"

class ListOfFriends {
   public:
      // constructor
      ListOfFriends();
      ListOfFriends(const ListOfFriends& list);
      ~ListOfFriends();

      // overloaded operators
      ListOfFriends& operator=(const ListOfFriends& list);

      // printing
      void print();

      // mutator
      void add(const Friend& f);

   private:
      struct Node* root;
      void addto(Node*& p, Node* newNode);
      void visit(const Node* const p);
}; // class ListOfFriends

#endif
